#include <stdio.h>
#include <string.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <avr/iocan128.h>
#include <avr/iocanxx.h>
#include <avr/pgmspace.h>
#include <avr/io.h>
#include <stdlib.h>
#include <util/delay.h>
#include <avr/eeprom.h>
#include <avr/wdt.h>
#include "define.h"
#include "global.h"
#include "twi-master.h"
#include "delay.h"

volatile unsigned char uartReady;/*variable for Uart interrupt*/
char uartString[BUFFER_SIZE]; /* variable for storage received a complete string via UART */ 
char decrypt_uartString[BUFFER_SIZE]; 
char tempstr[BUFFER_SIZE];/*variable for debug*/
unsigned char nextCharPos; /*pointer of the variable uartString  */
volatile unsigned char timer0Ready;/*variable for Timer0  Interrupt*/


int main(void)
{
	/* initialize flag */
	nextCharPos = 0;
	uartReady = 0;
	timer0Ready = 0;
	uint8_t i;
	uint8_t j=0;
	uint8_t Data[8];
	uint8_t Data_to_sent= 0x52;
	uint8_t Command_to_sent[3];
;
	Command_to_sent[0]=0x01;
	Command_to_sent[1]=0X02;
	Command_to_sent[2]=0x03;
	uint8_t SlaveAddress = 0x1B;
	cli();  /*interrupt disable */
	UART0_Init(); /* initialize serial interface */
	/*
** Initiate TWI Master Interface with bitrate of 250 kHz
*/
	if (!TWIM_Init (250000))
		{
	        snprintf_P(tempstr,BUFFER_SIZE-1,PSTR("Error in initiating TWI interface %s"));
	        UART0_Send_Message_String(tempstr);
		while (1);
		}
		
/*Endless loop*/
	
	sei(); /*interrupt enable */
	
	while( 1 ) 
	{

/*
** Write byte(s) to the slave.
** It is implicitely assumed, that the slave will
** accepts 3 bytes
*/
    	       if (!TWIM_Start (SlaveAddress, TWIM_WRITE))
			{
			TWIM_Stop ();
	                snprintf_P(tempstr,BUFFER_SIZE-1,PSTR("Could not start TWI Bus for WRITE: %s"));
	                UART0_Send_Message_String(tempstr);
	    	}
		else
			{
			for (i=0;i<3;i++)
				{
		                 TWIM_Write (Command_to_sent);
			         snprintf_P(tempstr,BUFFER_SIZE-1,PSTR("Command_to_sent: %x"),Command_to_sent[i]);
 			         UART0_Send_Message_String(tempstr);
// 				 TWIM_Write (Data_to_sent);
// 			         snprintf_P(tempstr,BUFFER_SIZE-1,PSTR("Command_to_sent: %x"),Data_to_sent);
//  			         UART0_Send_Message_String(tempstr);
				
				}
			TWIM_Stop ();
			
// 			for (i=0;i<8;i++)
// 				{
// 	        	TWIM_Write (j++);
// 				printf ("Byte %d sent: %d\n", i, j);
// 				}
			Delay_ms (1000);
			}
			
/*
** Read byte(s) from the slave.
** It is implicitely assumed, that the slave will send
** 3 bytes
*/
//     	       if (!TWIM_Start (SlaveAddress, TWIM_READ))
// 			{
// 			TWIM_Stop ();
// 			printf ("Could not start TWI Bus for READ\n");
// 	    	}
// 		else
// 			{
// 			for (i=0;i<2;i++)
// 				{
// 	        	Data[i] = TWIM_ReadAck ();
// 			snprintf_P(tempstr,BUFFER_SIZE-1,PSTR("Reading Byte %d: %d"), i, Data[i]);
//  			UART0_Send_Message_String(tempstr);
// 				}
//         	        Data[2] = TWIM_ReadNack ();
// 			snprintf_P(tempstr,BUFFER_SIZE-1,PSTR("Reading Byte %d: %d"), i, Data[2]);
//  			UART0_Send_Message_String(tempstr);
// 			TWIM_Stop ();
// 			Delay_ms (1000);
// 			}
/*
/*
** Do something else
*/
		i++;
		}

	return 0;
		
	
}	

	




